﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.AnalysisServices.AdomdClient;

namespace ADOMD.NET_Metadata_Sample
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnLoad_Click(object sender, EventArgs e)
        {
            int nCubes = 0;

            tvMetadata.Nodes.Clear();

            AdomdConnection mdcon = new AdomdConnection(tbConnString.Text);
            mdcon.Open();


            foreach (CubeDef cube in mdcon.Cubes)
            {
                if (cube.Name.StartsWith("$"))
                    continue;
                tvMetadata.Nodes.Add(cube.Name + " (" + cube.LastProcessed.ToString() + ")");

                tvMetadata.Nodes[nCubes].Nodes.Add("Measures");
                foreach (Measure mes in cube.Measures)
                    tvMetadata.Nodes[nCubes].Nodes[0].Nodes.Add(mes.Name);

                tvMetadata.Nodes[nCubes].Nodes.Add("Dimensionen");
                int nDims = 0;
                foreach (Dimension dim in cube.Dimensions)
                {
                    tvMetadata.Nodes[nCubes].Nodes[1].Nodes.Add(dim.Name);

                    foreach(Hierarchy hier in dim.Hierarchies)
                        tvMetadata.Nodes[nCubes].Nodes[1].Nodes[nDims].Nodes.Add(hier.Name);
                    
                    nDims++;
                }

                tvMetadata.Nodes[nCubes].Nodes.Add("KPIs");
                foreach (Kpi kpi in cube.Kpis)
                    tvMetadata.Nodes[nCubes].Nodes[2].Nodes.Add(kpi.Name);

                nCubes++;
            }

            mdcon.Close();

        }

    }
}
